-- Rocketry v0.0.5 code by Astro & Lisi

function love.load()
fueltex = love.graphics.newImage("fuelcan.png")
atmos = love.graphics.newImage("atmosphere.png")
outatmos = love.graphics.newImage("outeratmosphere.png")
luna = love.graphics.newImage("luna.png")

cone = love.graphics.newImage("lvl1cone.png")
shaft = love.graphics.newImage("lvl1shaft.png")
engine = love.graphics.newImage("lvl1engine.png")
eflame = love.graphics.newImage("engineflame.png")

lvl2cone = love.graphics.newImage("lvl2cone.png")
lvl2shaft = love.graphics.newImage("lvl2shaft.png")
lvl2engine = love.graphics.newImage("lvl2engine.png")

lvl3cone = love.graphics.newImage("lvl3cone.png")
lvl3shaft = love.graphics.newImage("lvl3shaft.png")
lvl3engine = love.graphics.newImage("lvl3engine.png")

rocket = {}
rocket.com = 15
rocket.mass = 20
rocket.thrust = 40
rocket.x = 200
rocket.yaw = 0
rocket.fuel = 300
rocket.maxfuel = 400
rocket.fuelbrate = 0.2
rocket.prograde = 1
rocket.sci = 0
rocket.altitude = 0
rocket.lp = true
rocket.inorbit = false
rocket.ev = false
rocket.lunafb = false
rocket.ms = false
rocket.name = "The Dreamer"

inventory = {}
inventory.level1 = true
inventory.level2 = false
inventory.level3 = false

atmosph = {}
atmosph.y = -200
atmosph.y2 = -975

message = {}
message.x = 10
message.y = 25
message.text = ""
lunay = -1200

altitudex = 370
paid = true
timeofday = 255 -- 50 = night 255 = noon

flamex = 500
coney = 527
shafty = 531
enginey = 545
eflamey = 550
grav = 50

end

function love.update(dt)

if(love.keyboard.isDown("`")) then
rocket.inorbit = false
rocket.prograde = 2
if rocket.ev and paid == false then
rocket.sci = rocket.sci + 25
if(rocket.lunafb == true) then
rocket.sci = rocket.sci + 35
end
paid = true
end
end

if(rocket.fuel <= 0) and rocket.ev == false then
rocket.prograde = 2 
end

if(love.keyboard.isDown(" ")) and (rocket.fuel >= 1) then
rocket.fuel = rocket.fuel - rocket.fuelbrate
atmosph.y = atmosph.y + rocket.thrust * dt
atmosph.y2 = atmosph.y2 + rocket.thrust * dt
lunay = lunay + rocket.thrust * dt
rocket.altitude = math.floor(rocket.altitude + 1)
paid = false
flamex = rocket.x

if rocket.prograde == 2 then
rocket.prograde = 1
end

if rocket.lp == true then
rocket.lp = false
end

-- Engine exhaust will be added in v0.2.0 - Astro
end

if(love.keyboard.isDown(" ") and rocket.fuel <= 0) then
rocket.prograde = 2
end

if(love.keyboard.isDown("f") and (rocket.ms == true)) then
-- Separate a stage and continue
end

if(love.keyboard.isDown("a")) then
rocket.x = rocket.x - rocket.thrust * dt
flamex = flamex - rocket.thrust * dt
elseif(love.keyboard.isDown("d")) then
rocket.x = rocket.x + rocket.thrust * dt
flamex = flamex + rocket.thrust * dt
end

if(rocket.prograde == 2) then
atmosph.y = atmosph.y - (rocket.mass + grav) * dt
atmosph.y2 = atmosph.y2 - (rocket.mass + grav) * dt
lunay = lunay - (rocket.mass + grav) * dt
rocket.altitude = rocket.altitude - 1

if(rocket.altitude <= 0) then
reset()
end

if flamex <= 400 then
flamex = 500
end

if(eflamey <= 540) then
rocket.prograde = 1
end

end

if rocket.inorbit == true then
message.text = "REACHED EARTH ESCAPE VELOCITY: +25 Science!"
rocket.ev = true
end

if rocket.lunafb == true then
message.text = "LUNAR FLY-BY: +35 Science!"
end

if not love.keyboard.isDown(" ") then
if(rocket.lp == true) or (rocket.inorbit == true) then
return
else
rocket.prograde = 2
end
end

if rocket.altitude >= 1300 then
rocket.inorbit = true
end

if rocket.altitude >= 2400 then
rocket.lunafb = true
end

if rocket.altitude >= 1000 then
if altitudex == 370 then
altitudex = 360
end
end
end

function love.draw()
for i = 0, love.graphics.getWidth() / atmos:getWidth() do
for j = 0, love.graphics.getHeight() / atmos:getHeight() do
love.graphics.draw(atmos, 0, atmosph.y)
end
end

for i = 0, love.graphics.getWidth() / outatmos:getWidth() do
for j = 0, love.graphics.getHeight() / outatmos:getHeight() do
love.graphics.draw(outatmos, 0, atmosph.y2)
end
end

love.graphics.setColor(255, 255, 255, timeofday)
love.graphics.setColor(255, 255, 255, timeofday)
love.graphics.draw(cone, rocket.x, coney)
love.graphics.draw(shaft, rocket.x, shafty)
love.graphics.draw(engine, rocket.x, enginey)
love.graphics.draw(eflame, flamex, eflamey)

love.graphics.setColor(150, 150, 150, timeofday)
love.graphics.rectangle("fill", 2, 2, 395, 22) -- Dashboard back
love.graphics.setColor(50, 50, 50, timeofday)
love.graphics.rectangle("fill", 60, 5, 200, 16)
love.graphics.setColor(255, 255, 255, timeofday)
love.graphics.draw(fueltex, 5,5)
love.graphics.print(math.floor(rocket.fuel), 25, 7)
love.graphics.print(rocket.altitude, altitudex, 7)
love.graphics.print(rocket.name, 65, 7)
love.graphics.setColor(225, 0, 0, 255)
love.graphics.print(message.text, message.x, message.y)
love.graphics.setColor(255, 255, 255, 255)
love.graphics.print(math.floor(rocket.sci), 260, 7)
love.graphics.draw(luna, 100, lunay)
end

function reset()
coney = 527
shafty = 531
enginey = 545
eflamey = 550
rocket.prograde = 1
rocket.fuel = rocket.maxfuel
rocket.x = 200
atmosph.y = -200
atmosph.y2 = -975
rocket.altitude = 0

if (rocket.sci >= 75) and (inventory.level1 == true) then
rocket.sci = rocket.sci - 75
inventory.level2 = true
cone = lvl2cone
shaft = lvl2shaft
engine = lvl2engine
rocket.thrust = 50
rocket.maxfuel = 400
enginey = 543
message.text = "Level 2 rocket unlocked! (+10% thrust, +35% max fuel, -75 science)"
rocket.name = "Authority"
end

if (rocket.sci >= 250) and (inventory.level2 == true) then
rocket.sci = rocket.sci - 250
inventory.level2 = true
cone = lvl3cone
shaft = lvl3shaft
engine = lvl3engine
rocket.fuelbrate = 0.1
rocket.maxfuel = 800
enginey = 543
message.text = "Level 3 rocket unlocked! (+100% max fuel, -50% fuel burn rate, -250 science)"
rocket.name = "Adventure"
coney = 521
end
end
